#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

#include "../shared/debug.h"

#include "drivers/lcd.h"

#include "clients.h"
#include "screen.h"
#include "screenlist.h"
#include "widget.h"

#include "serverscreens.h"

screen *server_screen;
char *id = "ClientList";
char *name = "Client List";

char title[256] = "LCDproc Server";
char one[256]   = "Clients: 0";
char two[256]   = "Screens: 0";
char three[256] = "";

int server_screen_init()
{
   widget *w;

   debug("server_screen_init\n");
   
   server_screen = screen_create();

   if(!server_screen)
   {
      fprintf(stderr, "server_screen_init: Error allocating screen\n");
      return -1;
   }

   server_screen->id = id;
   server_screen->name = name;
   
   // TODO:  Error-checking?
   widget_add(server_screen, "title", "title", NULL, 1);
   widget_add(server_screen, "one"  , "string", NULL, 1);
   widget_add(server_screen, "two"  , "string", NULL, 1);
   widget_add(server_screen, "three", "string", NULL, 1);


   // Now, initialize all the widgets...
   w = widget_find(server_screen, "title");
   if(w)
   {
      w->text = title;
   }
   else
   {
      fprintf(stderr, "server_screen_init: Can't find title\n");
   }
   
   w = widget_find(server_screen, "one");
   if(w)
   {
      w->x = 1;
      w->y = 2;
      w->text = one;
   }
   else
   {
      fprintf(stderr, "server_screen_init: Can't find widget one\n");
   }
   
   w = widget_find(server_screen, "two");
   if(w)
   {
      w->x = 1;
      w->y = 3;
      w->text = two;
   }
   else
   {
      fprintf(stderr, "server_screen_init: Can't find widget two\n");
   }
   
   w = widget_find(server_screen, "three");
   if(w)
   {
      w->x = 1;
      w->y = 4;
      w->text = three;
   }
   else
   {
      fprintf(stderr, "server_screen_init: Can't find widget three\n");
   }
   

   
   // And enqueue the screen
   screenlist_add(server_screen);

   debug("server_screen_init done\n");
   
   return 0;
}


int update_server_screen(int timer)
{
   client *c;
   int num_clients;
   screen *s;
   int num_screens;
   
   
   // Draw a title...
   //strcpy(title, "LCDproc Server");


   // Now get info on the number of connected clients...
   num_clients=0; num_screens=0;
   LL_Rewind(clients);
   do {
      c = LL_Get(clients);
      if(c)
      {
	 num_clients++;
	 LL_Rewind(c->data->screenlist);
	 do {
	    s = LL_Get(c->data->screenlist);
	    if(s)
	    {
	       num_screens++;
	    }
	 } while(LL_Next(c->data->screenlist) == 0);
      }
   } while(LL_Next(clients) == 0);

   sprintf(one, "Clients: %i", num_clients);
   sprintf(two, "Screens: %i", num_screens);
   
   return 0;
}

int no_screen_screen(int timer)
{
   
   lcd.clear();

   lcd.string(1, 1, "Error:  No screen!");
   
   lcd.flush();
   
   return 0;
}

int goodbye_screen()
{
   
   lcd.clear();

   lcd.string(1, 1, "                    ");
   lcd.string(1, 2, "  Thanks for using  ");
#ifdef LINUX
   lcd.string(1, 3, " LCDproc and Linux! ");
#else
   lcd.string(1, 3, "      LCDproc!      ");
#endif
   lcd.string(1, 4, "                    ");
   
   lcd.flush();
   
   return 0;
}

